package sdk

import (
	"os"

	openedge "github.com/baidu/openedge/api/go"
)

// Run service
func Run(handle func(openedge.Context) error) {
	ctx, err := newContext()
	if err != nil {
		openedge.Fatalln("failed to create context:", err.Error())
	}
	defer ctx.Close()
	err = handle(ctx)
	if err != nil {
		openedge.Errorln("failed to run service:", err.Error())
		os.Exit(1)
	}
}
